alter table appliance_feeds modify provider_name varchar(255) default null;
alter table appliance_feeds modify feed_name varchar(255) not null;
alter table emailsetup modify mail_server varchar(255) default null;
alter table entities modify name varchar(255) not null;
alter table entities modify created_by varchar(255) default null;
alter table entities modify modified_by varchar(255) default null;
alter table entity_types modify created_by varchar(255) default null;
alter table entity_types modify modified_by varchar(255) default null;
alter table groups modify group_name varchar(255) not null;
alter table groups modify created_by varchar(255) default null;
alter table groups modify modified_by varchar(255) default null;
alter table image_groups modify id varchar(255) not null;
alter table image_stores modify name varchar(255) not null;
alter table images modify name varchar(255) not null;
alter table managed_nodes modify hostname varchar(255) not null;
alter table managed_nodes modify address varchar(255) default null;
alter table managed_nodes add socket int(11) default null after hostname;
alter table metrics modify id varchar(50) not null;
alter table metrics_arch modify id varchar(50) not null;
alter table metrics_curr modify id varchar(50) not null;
alter table notification modify user_name varchar(255) default null;
alter table notification add subject varchar(255) default null;
alter table operation_groups modify created_by varchar(255) default null;
alter table operation_groups modify modified_by varchar(255) default null;
alter table operations modify created_by varchar(255) not null;
alter table operations modify modified_by varchar(255) not null;
alter table server_groups modify name varchar(255) not null;
create index `ser_name` on services (`name`);
alter table storage_definitions drop column stats;
alter table storage_disks modify unique_path varchar(300) default null;
ALTER TABLE storage_disks add transient_reservation VARCHAR(50) default null;
alter table storage_stats modify id varchar(50) not null;
alter table storage_stats drop column used;
alter table storage_stats add entity_id varchar(50) after id;
alter table storage_stats add used_size float default null;
alter table storage_stats add available_size float default null;
alter table storage_stats add allocation_in_DC float default null;
alter table storage_stats add allocation_in_SP float default null;
alter table storage_stats add storage_used_in_SP float default null;
alter table storage_stats add storage_avail_in_SP float default null;
alter table storage_stats add allocation_at_S_for_DC float default null;
alter table storage_stats add allocation_at_S_for_SP float default null;
alter table storage_stats add local_storage_at_VM float default null;
alter table storage_stats add shared_storage_at_VM float default null;
alter table storage_stats add storage_allocation_at_DC float default null;
alter table storage_stats add locked boolean;
alter table storage_stats drop index `strgestat_id`;
create index `idx_ss_entid_sid` on storage_stats (`entity_id`,`storage_id`);
alter table task_intervals change column `interval` task_interval int(11) default null;
alter table task_calendars modify day bigint(20) default null ;
alter table task_calendars modify minute bigint(20) default null;
create index `tc_ne` on task_calendars (`dow`,`month`,`day`,`hour`,`minute`);
create index `ti_ne` on task_intervals (`next_execution`);
alter table task_results add exec_context blob ;
alter table task_results add cancel_requested tinyint(1) default 0;
alter table task_results add visible tinyint(1) default 0;
alter table task_results drop index tr_tid;
create index tr_composite on task_results (`task_id`,`timestamp`,`status`,`visible`);
alter table tasks add repeating tinyint(1) default null;
alter table tasks add cancellable tinyint(1) default 0;
alter table tasks add parent_task_id int(11) default null;
alter table tasks drop index task_id_eid;
create index task_eid_time_uname on tasks (`entity_id`,`submitted_on`,`user_name`);
alter table tasks modify entity_id varchar(50) default null;
alter table tasks modify entity_name varchar(255) default null;
alter table tasks modify user_name varchar(255) default null;
alter table users modify user_name varchar(255) not null;
alter table users modify created_by varchar(255) default null;
alter table users modify modified_by varchar(255) default null;
alter table vm_disks modify disk_name varchar(300) default null;
alter table vm_disks add sequence int(11) default null;
alter table vms modify name varchar(255) not null;
alter table vms modify created_user varchar(255) default null;
alter table appliance_catalogs ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table appliance_feeds ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table appliances ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table credentials ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table dcdeflinks ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table dependencies ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table deployment ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table emailsetup ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table entities ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table entity_attributes ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table entity_relations ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table entity_types ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table group_permission ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table groups ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table image_groups ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table image_stores ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table images ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table managed_nodes ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table metrics ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table metrics_arch ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table metrics_curr ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table network_definitions ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table node_config ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table nodeinfo_categories ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table nodeinfo_components ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table nodeinfo_instances ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table notification ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table operation_groups ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table operation_opgroup ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table operations ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table ops_enttypes ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table permissions ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table purge_config ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table rollup_status ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table server_groups ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table serverdeflinks ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table services ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table sites ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table spdeflinks ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table storage_definitions ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table storage_disks ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table storage_stats ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table task_calendars ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table task_intervals ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table task_results ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table tasks ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table user_group ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table users ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table vm_disks ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table vm_storage_links ENGINE=InnoDB DEFAULT CHARSET=utf8;
alter table vms ENGINE=InnoDB DEFAULT CHARSET=utf8;

